/*
 * Sonar, open source software quality management tool.
 * Copyright (C) 2008-2012 SonarSource
 * mailto:contact AT sonarsource DOT com
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sonar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package org.sonar.plugins.dbcleaner.api;

import org.sonar.api.BatchExtension;
import org.sonar.api.database.DatabaseSession;

/**
 * Implement this component in order to define your own rules to cleanup database.
 *
 * @since 2.5
 * @deprecated in 2.14
 */
@Deprecated
public abstract class Purge implements BatchExtension {

  private DatabaseSession session;

  protected Purge(DatabaseSession session) {
    this.session = session;
  }

  protected final DatabaseSession getSession() {
    return session;
  }

  /**
   * Snapshots include the current snapshot (flagged as last) and optionally the penultimate one.
   *
   * @snapshots never null.
   */
  public abstract void purge(PurgeContext context);

  @Override
  public String toString() {
    return getClass().getName();
  }
}
